<?php
namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\AgendaServicosService;
use SM\Traits\TResponse;

class AgendaServicosController extends SMCrud
{
    use TResponse;

    protected $agendaServicosService;

    public function __construct(AgendaServicosService $agendaServicosService)
    {
        $this->agendaServicosService=$agendaServicosService;
    }

    public function getAgendaServicos(Request $request)
    {
        try {
            $data = $this->agendaServicosService->getAgendaServicos($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCliente()
    {
        try {
            $data = $this->agendaServicosService->getCliente();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getPropostaAgendaServicos(Request $request)
    {
        try {
            $data = $this->agendaServicosService->getPropostaAgendaServicos($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function zerarSaldoDeHoras(Request $request)
    {
        try {
            $data = $this->agendaServicosService->zerarSaldoDeHoras($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function zerarSaldoDeHorasAction(Request $request)
    {
        try {
            $data = $this->agendaServicosService->zerarSaldoDeHorasAction($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function editarSaldoDeHoras(Request $request)
    {
        try {
            $data = $this->agendaServicosService->editarSaldoDeHoras($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function reverterSaldoHoras(Request $request)
    {
        try {
            $data = $this->agendaServicosService->reverterSaldoHoras($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function reverterSaldoHorasAction(Request $request)
    {
        try {
            $data = $this->agendaServicosService->reverterSaldoHorasAction($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getLogAgendaServicos(Request $request)
    {
        try {
            $data = $this->agendaServicosService->getLogAgendaServicos($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
