<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class MapaFaturamentoFactory
{
    use TQuery;

    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }


    // select principal
    public function getMapaFaturamento($page, $limit, $conditions, $order)
    {   
      $startPos = ($page - 1) * $limit;
      $finalPos = $page * $limit;
      $sql  = <<<SQL
       SELECT  COUNT(1) OVER () TOTAL_LINES_ZHNEXT, C.* FROM (SELECT MES1.CDSERVORCA, MES1.NMSERVORCA,
                       NVL(MES1.COMPETENCIA1, TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')) AS COMPETENCIA1, NVL(MES1.ESTIMADO1, 0) AS ESTIMADO1, NVL(MES1.FATURADO1, 0) AS FATURADO1, NVL(MES1.DIFERENCA1, 0) AS DIFERENCA1, NVL(MES1.DESVIO1, 0) AS DESVIO1,
                       NVL(MES2.COMPETENCIA2, TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')) AS COMPETENCIA2, NVL(MES2.ESTIMADO2, 0) AS ESTIMADO2, NVL(MES2.FATURADO2, 0) AS FATURADO2, NVL(MES2.DIFERENCA2, 0) AS DIFERENCA2, NVL(MES2.DESVIO2, 0) AS DESVIO2,
                       NVL(MES3.COMPETENCIA3, TO_CHAR(SYSDATE, 'MM/YYYY')) AS COMPETENCIA3, NVL(MES3.ESTIMADO3, 0) AS ESTIMADO3, NVL(MES3.FATURADO3, 0) AS FATURADO3, NVL(MES3.DIFERENCA3, 0) AS DIFERENCA3, NVL(MES3.DESVIO3, 0) AS DESVIO3,
                       CASE WHEN ((MES1.DIFERENCA1 = 0) OR (MES2.DIFERENCA2 = 0) OR (MES3.DIFERENCA3 = 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS NAO_DIFERENCA,
                       CASE WHEN ((MES1.DESVIO1 > 0) OR (MES2.DESVIO2 > 0) OR (MES3.DESVIO3 > 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_POSITIVO,
                       CASE WHEN ((MES1.DESVIO1 < 0) OR (MES2.DESVIO2 < 0) OR (MES3.DESVIO3 < 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_NEGATIVO,
                       CASE WHEN ((MES1.DESVIO1 = 0) OR (MES2.DESVIO2 = 0) OR (MES3.DESVIO3 = 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_ZERADO,
                       '' AS DESVIO_SINAL
               FROM (SELECT CDSERVORCA, NMSERVORCA, COMPETENCIA1, SUM(ESTIMADO1) AS ESTIMADO1 , SUM(FATURADO1) AS FATURADO1, SUM(DIFERENCA1) AS DIFERENCA1,
							ROUND(((SUM(DIFERENCA1)/DECODE(SUM(ESTIMADO1),0,1,SUM(ESTIMADO1)))*100),2) AS DESVIO1
					  FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA1, 
					  
								   ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2) AS ESTIMADO1,
								   
								   ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO1, 
								   
								   ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) AS DIFERENCA1,
								   
								   ROUND((ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) / DECODE(ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2),0,1, ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2)))*100,2) AS DESVIO1
							  FROM FCT_FATURACONT FAT
							  JOIN FCT_ITFATURACONT ITEM
							    ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
				  			  JOIN FCT_ITEMCONTRATO ITCONT
							    ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
							  JOIN FCT_SERVICOORCA SERV
							    ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
						      JOIN FCT_CONTRATO CONT 
						        ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
						      LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
						        ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
						      LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
							    ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
							   AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO	
						      LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, MAX(NRPARCELA) AS QTPARCELA
								  		   FROM FCT_PARCELANEGOCONT
									      GROUP BY NRNEGOCIACAOCONTRATO) PARCELA
								ON PARCELA.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO  
							  LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, DTFINALVALIDADEDESC, VRPERCDESCITEM
                                           FROM FCT_DESCPERIODONEGOCONT
                                          WHERE DTFINALVALIDADEDESC IS NOT NULL) DESCONTOPER
                                      ON DESCONTOPER.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                                     AND DESCONTOPER.DTFINALVALIDADEDESC <= FAT.DTFINCOMPET
							 WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')
							 GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY'), PARCELA.QTPARCELA)
					GROUP BY CDSERVORCA, NMSERVORCA, COMPETENCIA1
                    ORDER BY  NMSERVORCA) MES1
               LEFT JOIN (SELECT CDSERVORCA, NMSERVORCA, COMPETENCIA2, SUM(ESTIMADO2) AS ESTIMADO2 , SUM(FATURADO2) AS FATURADO2, SUM(DIFERENCA2) AS DIFERENCA2,
							ROUND(((SUM(DIFERENCA2)/DECODE(SUM(ESTIMADO2),0,1,SUM(ESTIMADO2)))*100),2) AS DESVIO2
					  FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA2, 
								   ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2) AS ESTIMADO2,
								   ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO2, 
								   ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) AS DIFERENCA2,
								   ROUND((ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) / DECODE(ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2),0,1, ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2)))*100,2) AS DESVIO2
							  FROM FCT_FATURACONT FAT
							  JOIN FCT_ITFATURACONT ITEM
							    ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
				  			  JOIN FCT_ITEMCONTRATO ITCONT
							    ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
							  JOIN FCT_SERVICOORCA SERV
							    ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
						      JOIN FCT_CONTRATO CONT 
						        ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
						      LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
						        ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
						      LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
							    ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
							   AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO	
						      LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, MAX(NRPARCELA) AS QTPARCELA
								  		   FROM FCT_PARCELANEGOCONT
									      GROUP BY NRNEGOCIACAOCONTRATO) PARCELA
								ON PARCELA.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
							  LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, DTFINALVALIDADEDESC, VRPERCDESCITEM
                                           FROM FCT_DESCPERIODONEGOCONT
                                          WHERE DTFINALVALIDADEDESC IS NOT NULL) DESCONTOPER
                                      ON DESCONTOPER.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                                     AND DESCONTOPER.DTFINALVALIDADEDESC <= FAT.DTFINCOMPET
							 WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')
							 GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY'), PARCELA.QTPARCELA)
					GROUP BY CDSERVORCA, NMSERVORCA, COMPETENCIA2
                    ORDER BY  NMSERVORCA) MES2
                 ON MES2.CDSERVORCA = MES1.CDSERVORCA
               LEFT JOIN (SELECT CDSERVORCA, NMSERVORCA, COMPETENCIA3, SUM(ESTIMADO3) AS ESTIMADO3 , SUM(FATURADO3) AS FATURADO3, SUM(DIFERENCA3) AS DIFERENCA3,
							ROUND(((SUM(DIFERENCA3)/DECODE(SUM(ESTIMADO3),0,1,SUM(ESTIMADO3)))*100),2) AS DESVIO3
					  FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA3, 
								   ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2) AS ESTIMADO3,
								   ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO3, 
								   ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) AS DIFERENCA3,
								   ROUND((ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) / DECODE(ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2),0,1, ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2)))*100,2) AS DESVIO3
							  FROM FCT_FATURACONT FAT
							  JOIN FCT_ITFATURACONT ITEM
							    ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
				  			  JOIN FCT_ITEMCONTRATO ITCONT
							    ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
							  JOIN FCT_SERVICOORCA SERV
							    ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
						      JOIN FCT_CONTRATO CONT 
						        ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
						      LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
						        ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
						      LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
							    ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
							   AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO	
						      LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, MAX(NRPARCELA) AS QTPARCELA
								  		   FROM FCT_PARCELANEGOCONT
									      GROUP BY NRNEGOCIACAOCONTRATO) PARCELA
								ON PARCELA.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO  
							  LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, DTFINALVALIDADEDESC, VRPERCDESCITEM
                                           FROM FCT_DESCPERIODONEGOCONT
                                          WHERE DTFINALVALIDADEDESC IS NOT NULL) DESCONTOPER
                                      ON DESCONTOPER.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                                     AND DESCONTOPER.DTFINALVALIDADEDESC <= FAT.DTFINCOMPET
							 WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(SYSDATE , 'MM/YYYY')
							 GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY'), PARCELA.QTPARCELA)
					GROUP BY CDSERVORCA, NMSERVORCA, COMPETENCIA3
                    ORDER BY  NMSERVORCA) MES3
                 ON MES3.CDSERVORCA = MES1.CDSERVORCA) C
              $conditions
              $order
              OFFSET $startPos ROWS FETCH NEXT $limit ROWS ONLY
SQL;

        $result = $this->entityManager->getConnection()->fetchAll($sql);

        $total = empty($result) ? 0 : $result[0]['TOTAL_LINES_ZHNEXT'];
        $returnNext = [ 'data' => $result, 'pagination' => [ 'limit' => $limit, 'page' => $page, 'total' => $total]];
        return $returnNext;
    }

    // Trás parceiros de negócio
    public function getMapaFaturamentoParc($parametros, $page, $limit, $conditions, $order)
    {
      $startPos = ($page - 1) * $limit;
      $finalPos = $page * $limit;
      $sql  = <<<SQL
       SELECT  COUNT(1) OVER () TOTAL_LINES_ZHNEXT, C.* FROM (SELECT DISTINCT BASE.CDSERVORCA, BASE.NMSERVORCA, BASE.NRPARCFATURA AS NRPARCNEGOCIO, BASE.NMPARCEIRO,
                       NVL(MES1.COMPETENCIA1, TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')) AS COMPETENCIA1, NVL(MES1.ESTIMADO1, 0) AS ESTIMADO1, NVL(MES1.FATURADO1, 0) AS FATURADO1, NVL(MES1.DIFERENCA1, 0) AS DIFERENCA1, NVL(MES1.DESVIO1, 0) AS DESVIO1,
                       NVL(MES2.COMPETENCIA2, TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')) AS COMPETENCIA2, NVL(MES2.ESTIMADO2, 0) AS ESTIMADO2, NVL(MES2.FATURADO2, 0) AS FATURADO2, NVL(MES2.DIFERENCA2, 0) AS DIFERENCA2, NVL(MES2.DESVIO2, 0) AS DESVIO2,
                       NVL(MES3.COMPETENCIA3, TO_CHAR(SYSDATE, 'MM/YYYY')) AS COMPETENCIA3, NVL(MES3.ESTIMADO3, 0) AS ESTIMADO3, NVL(MES3.FATURADO3, 0) AS FATURADO3, NVL(MES3.DIFERENCA3, 0) AS DIFERENCA3, NVL(MES3.DESVIO3, 0) AS DESVIO3,
                       CASE WHEN ((MES1.DIFERENCA1 = 0) OR (MES2.DIFERENCA2 = 0) OR (MES3.DIFERENCA3 = 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS NAO_DIFERENCA,
                       CASE WHEN ((MES1.DESVIO1 > 0) OR (MES2.DESVIO2 > 0) OR (MES3.DESVIO3 > 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_POSITIVO,
                       CASE WHEN ((MES1.DESVIO1 < 0) OR (MES2.DESVIO2 < 0) OR (MES3.DESVIO3 < 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_NEGATIVO,
                       CASE WHEN ((MES1.DESVIO1 = 0) OR (MES2.DESVIO2 = 0) OR (MES3.DESVIO3 = 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_ZERADO,
                       '' AS DESVIO_SINAL
                 FROM (SELECT DISTINCT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRPARCNEGOCIO AS NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO
                         FROM FCT_CONTRATO CONT
                         JOIN PARCNEGOCIO PARC 
                           ON PARC.NRPARCNEGOCIO = CONT.NRPARCNEGOCIO
                         JOIN FCT_ITEMCONTRATO ITCONT
                           ON ITCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                         JOIN FCT_SERVICOORCA SERV
                           ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                          WHERE ITCONT.CDSERVORCA = :CDSERVORCA ) BASE 
                 
                LEFT JOIN (SELECT CDSERVORCA, NMSERVORCA, NRPARCFATURA, NMPARCEIRO, COMPETENCIA1, SUM(ESTIMADO1) AS ESTIMADO1 , SUM(FATURADO1) AS FATURADO1, SUM(DIFERENCA1) AS DIFERENCA1,
							ROUND(((SUM(DIFERENCA1)/DECODE(SUM(ESTIMADO1),0,1,SUM(ESTIMADO1)))*100),2) AS DESVIO1
					  FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA1, 
                                   ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2) AS ESTIMADO1, 
                                   ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO1, 
                                   ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) AS DIFERENCA1,
                                   ROUND((ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) / DECODE(ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2),0,1, ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2)))*100, 2) AS DESVIO1
                                   FROM FCT_FATURACONT FAT
                             JOIN FCT_ITFATURACONT ITEM
                               ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                             JOIN FCT_ITEMCONTRATO ITCONT
                               ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                             JOIN FCT_SERVICOORCA SERV
                               ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                             JOIN PARCNEGOCIO PARC 
                               ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
                           JOIN FCT_CONTRATO CONT 
                           ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                           LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
                           ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                           LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
                           ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
                           AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
                           LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, MAX(NRPARCELA) AS QTPARCELA
                                        FROM FCT_PARCELANEGOCONT
                                      GROUP BY NRNEGOCIACAOCONTRATO) PARCELA
                                ON PARCELA.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO  
                           LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, DTFINALVALIDADEDESC, VRPERCDESCITEM
                                                       FROM FCT_DESCPERIODONEGOCONT
                                                      WHERE DTFINALVALIDADEDESC IS NOT NULL) DESCONTOPER
                                                  ON DESCONTOPER.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                                                 AND DESCONTOPER.DTFINALVALIDADEDESC <= FAT.DTFINCOMPET	
                           WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')
                           AND ITCONT.CDSERVORCA = :CDSERVORCA
                             GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY'), PARCELA.QTPARCELA)
               GROUP BY CDSERVORCA, NMSERVORCA, NRPARCFATURA, NMPARCEIRO, COMPETENCIA1
               ORDER BY NMSERVORCA ) MES1
               ON MES1.CDSERVORCA = BASE.CDSERVORCA
               AND MES1.NRPARCFATURA = BASE.NRPARCFATURA    
                   
               LEFT JOIN (SELECT CDSERVORCA, NMSERVORCA, NRPARCFATURA, NMPARCEIRO, COMPETENCIA2, SUM(ESTIMADO2) AS ESTIMADO2 , SUM(FATURADO2) AS FATURADO2, SUM(DIFERENCA2) AS DIFERENCA2,
							ROUND(((SUM(DIFERENCA2)/DECODE(SUM(ESTIMADO2),0,1,SUM(ESTIMADO2)))*100),2) AS DESVIO2
					  FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO,  TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA2, 
                                   ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2) AS ESTIMADO2, 
                                   ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO2, 
                                   ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) AS DIFERENCA2,
                                   ROUND((ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) / DECODE(ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2),0,1, ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2)))*100,2) AS DESVIO2
                              FROM FCT_FATURACONT FAT
                              JOIN FCT_ITFATURACONT ITEM
                                ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                              JOIN FCT_ITEMCONTRATO ITCONT
                                ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                              JOIN FCT_SERVICOORCA SERV
                                ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                              JOIN PARCNEGOCIO PARC 
                                ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
                              JOIN FCT_CONTRATO CONT 
                           ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                           LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
                           ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                           LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
                           ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
                           AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO 
                           LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, MAX(NRPARCELA) AS QTPARCELA
                                        FROM FCT_PARCELANEGOCONT
                                      GROUP BY NRNEGOCIACAOCONTRATO) PARCELA
                                ON PARCELA.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                           LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, DTFINALVALIDADEDESC, VRPERCDESCITEM
                                                       FROM FCT_DESCPERIODONEGOCONT
                                                      WHERE DTFINALVALIDADEDESC IS NOT NULL) DESCONTOPER
                                                  ON DESCONTOPER.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                                                 AND DESCONTOPER.DTFINALVALIDADEDESC <= FAT.DTFINCOMPET
                           WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')
                           AND ITCONT.CDSERVORCA = :CDSERVORCA
                             GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )',  TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY'), PARCELA.QTPARCELA)
                 GROUP BY CDSERVORCA, NMSERVORCA, NRPARCFATURA, NMPARCEIRO, COMPETENCIA2
                 ORDER BY NMSERVORCA) MES2
               ON MES2.CDSERVORCA = BASE.CDSERVORCA
               AND MES2.NRPARCFATURA = BASE.NRPARCFATURA
               
               
               LEFT JOIN (
               SELECT CDSERVORCA, NMSERVORCA, NRPARCFATURA, NMPARCEIRO, COMPETENCIA3, SUM(ESTIMADO3) AS ESTIMADO3 , SUM(FATURADO3) AS FATURADO3, SUM(DIFERENCA3) AS DIFERENCA3,
							ROUND(((SUM(DIFERENCA3)/DECODE(SUM(ESTIMADO3),0,1,SUM(ESTIMADO3)))*100),2) AS DESVIO3
					  FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA,  FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA3, 
                                   ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2) AS ESTIMADO3, 
                                   ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO3, 
                                   ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) AS DIFERENCA3,
                                   ROUND((ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) / DECODE(ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2),0,1, ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2)))*100,2) AS DESVIO3
                         FROM FCT_FATURACONT FAT
                         JOIN FCT_ITFATURACONT ITEM
                           ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                         JOIN FCT_ITEMCONTRATO ITCONT
                           ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                         JOIN FCT_SERVICOORCA SERV
                           ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                         JOIN PARCNEGOCIO PARC 
                           ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
                       JOIN FCT_CONTRATO CONT 
                       ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                       LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
                       ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                       LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
                       ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
                       AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
                       LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, MAX(NRPARCELA) AS QTPARCELA
                                    FROM FCT_PARCELANEGOCONT
                                  GROUP BY NRNEGOCIACAOCONTRATO) PARCELA
                            ON PARCELA.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO  
                        LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, DTFINALVALIDADEDESC, VRPERCDESCITEM
                                                   FROM FCT_DESCPERIODONEGOCONT
                                                  WHERE DTFINALVALIDADEDESC IS NOT NULL) DESCONTOPER
                                              ON DESCONTOPER.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                                             AND DESCONTOPER.DTFINALVALIDADEDESC <= FAT.DTFINCOMPET	
                       WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(SYSDATE, 'MM/YYYY')
                         AND ITCONT.CDSERVORCA = :CDSERVORCA
                       GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA,  FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY'), PARCELA.QTPARCELA)
               GROUP BY  CDSERVORCA, NMSERVORCA, NRPARCFATURA, NMPARCEIRO, COMPETENCIA3
               ORDER BY  NMSERVORCA) MES3
               ON MES3.CDSERVORCA = BASE.CDSERVORCA
               AND MES3.NRPARCFATURA = BASE.NRPARCFATURA
               WHERE ((MES1.COMPETENCIA1 IS NOT NULL) OR (MES2.COMPETENCIA2 IS NOT NULL) OR (MES3.COMPETENCIA3 IS NOT NULL))
               ORDER BY DESVIO1 ASC, DESVIO2 ASC, DESVIO3 ASC) C
              $conditions
              $order
              OFFSET $startPos ROWS FETCH NEXT $limit ROWS ONLY
SQL;

        $result = $this->entityManager->getConnection()->fetchAll($sql, $parametros);

        $total = empty($result) ? 0 : $result[0]['TOTAL_LINES_ZHNEXT'];
        $returnNext = [ 'data' => $result, 'pagination' => [ 'limit' => $limit, 'page' => $page, 'total' => $total]];
        return $returnNext;
    }

    // trás os contratos
    public function getMapaFaturamentoCli($parametros, $page, $limit, $conditions, $order)
    {
      $startPos = ($page - 1) * $limit;
      $finalPos = $page * $limit;
      $sql  = <<<SQL
       SELECT  COUNT(1) OVER () TOTAL_LINES_ZHNEXT, C.* FROM (SELECT BASE.CDSERVORCA, BASE.NMSERVORCA, BASE.NRSEQCONTRATO, BASE.CONTRATO, BASE.NRPARCFATURA, BASE.NMPARCEIRO, 
                       NVL(MES1.COMPETENCIA1, TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')) AS COMPETENCIA1, NVL(MES1.ESTIMADO1, 0) AS ESTIMADO1, NVL(MES1.FATURADO1, 0) AS FATURADO1, NVL(MES1.DIFERENCA1, 0) AS DIFERENCA1, NVL(MES1.DESVIO1, 0) AS DESVIO1,
                       NVL(MES2.COMPETENCIA2, TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')) AS COMPETENCIA2, NVL(MES2.ESTIMADO2, 0) AS ESTIMADO2, NVL(MES2.FATURADO2, 0) AS FATURADO2, NVL(MES2.DIFERENCA2, 0) AS DIFERENCA2, NVL(MES2.DESVIO2, 0) AS DESVIO2,
                       NVL(MES3.COMPETENCIA3, TO_CHAR(SYSDATE, 'MM/YYYY')) AS COMPETENCIA3, NVL(MES3.ESTIMADO3, 0) AS ESTIMADO3, NVL(MES3.FATURADO3, 0) AS FATURADO3, NVL(MES3.DIFERENCA3, 0) AS DIFERENCA3, NVL(MES3.DESVIO3, 0) AS DESVIO3,
                       CASE WHEN ((MES1.DIFERENCA1 = 0) OR (MES2.DIFERENCA2 = 0) OR (MES3.DIFERENCA3 = 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS NAO_DIFERENCA,
                       CASE WHEN ((MES1.DESVIO1 > 0) OR (MES2.DESVIO2 > 0) OR (MES3.DESVIO3 > 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_POSITIVO,
                       CASE WHEN ((MES1.DESVIO1 < 0) OR (MES2.DESVIO2 < 0) OR (MES3.DESVIO3 < 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_NEGATIVO,
                       CASE WHEN ((MES1.DESVIO1 = 0) OR (MES2.DESVIO2 = 0) OR (MES3.DESVIO3 = 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_ZERADO,
                       '' AS DESVIO_SINAL
                 FROM 
                 (SELECT DISTINCT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRPARCNEGOCIO AS NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO
                         FROM FCT_CONTRATO CONT
                         JOIN PARCNEGOCIO PARC 
                           ON PARC.NRPARCNEGOCIO = CONT.NRPARCNEGOCIO
                         JOIN FCT_ITEMCONTRATO ITCONT
                           ON ITCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                         JOIN FCT_SERVICOORCA SERV
                           ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                          WHERE ITCONT.CDSERVORCA = :CDSERVORCA 
                            AND CONT.NRPARCNEGOCIO = :NRPARCNEGOCIO) BASE 
                          
                 LEFT JOIN (SELECT CDSERVORCA, NMSERVORCA, NRSEQCONTRATO, CONTRATO, NRPARCFATURA, NMPARCEIRO, COMPETENCIA1, SUM(ESTIMADO1) AS ESTIMADO1 , SUM(FATURADO1) AS FATURADO1, SUM(DIFERENCA1) AS DIFERENCA1,
                                   ROUND(((SUM(DIFERENCA1)/DECODE(SUM(ESTIMADO1),0,1,SUM(ESTIMADO1)))*100),2) AS DESVIO1
                            FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA1, 
                                         ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2) AS ESTIMADO1, 
                                         ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO1, 
                                         ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) AS DIFERENCA1,
                                         ROUND((ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) / DECODE(ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2),0,1, ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2)))*100,2) AS DESVIO1
                                    FROM FCT_FATURACONT FAT
                                    JOIN FCT_ITFATURACONT ITEM
                                      ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                                    JOIN FCT_ITEMCONTRATO ITCONT
                                      ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                                    JOIN FCT_SERVICOORCA SERV
                                      ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                                    JOIN PARCNEGOCIO PARC 
                                      ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
                                    JOIN FCT_CONTRATO CONT
                                      ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                               LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
                                 ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                               LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
                                 ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
                                AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
                               LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, MAX(NRPARCELA) AS QTPARCELA
                                            FROM FCT_PARCELANEGOCONT
                                          GROUP BY NRNEGOCIACAOCONTRATO) PARCELA
                                    ON PARCELA.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO  
                               LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, DTFINALVALIDADEDESC, VRPERCDESCITEM
                                            FROM FCT_DESCPERIODONEGOCONT
                                           WHERE DTFINALVALIDADEDESC IS NOT NULL) DESCONTOPER
                                      ON DESCONTOPER.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                                     AND DESCONTOPER.DTFINALVALIDADEDESC <= FAT.DTFINCOMPET
                                 WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')
                                   AND SERV.CDSERVORCA = :CDSERVORCA
                                   AND PARC.NRPARCNEGOCIO = :NRPARCNEGOCIO
                                GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY'), PARCELA.QTPARCELA)
                   GROUP BY CDSERVORCA, NMSERVORCA, NRSEQCONTRATO, CONTRATO, NRPARCFATURA, NMPARCEIRO, COMPETENCIA1 
                   ORDER BY NMSERVORCA) MES1
                ON MES1.CDSERVORCA = BASE.CDSERVORCA
                 AND MES1.NRPARCFATURA = BASE.NRPARCFATURA
                 AND MES1.NRSEQCONTRATO = BASE.NRSEQCONTRATO 
                   
               LEFT JOIN (SELECT CDSERVORCA, NMSERVORCA, NRSEQCONTRATO, CONTRATO, NRPARCFATURA, NMPARCEIRO, COMPETENCIA2, 
                                 SUM(ESTIMADO2) AS ESTIMADO2 , SUM(FATURADO2) AS FATURADO2, SUM(DIFERENCA2) AS DIFERENCA2,
                                 ROUND(((SUM(DIFERENCA2)/DECODE(SUM(ESTIMADO2),0,1,SUM(ESTIMADO2)))*100),2) AS DESVIO2
                            FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO,  TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA2, 
                                         ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2) AS ESTIMADO2, 
                                         ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO2, 
                                         ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) AS DIFERENCA2,
                                         ROUND((ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) / DECODE(ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2),0,1, ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2)))*100,2) AS DESVIO2 
                                    FROM FCT_FATURACONT FAT
                                    JOIN FCT_ITFATURACONT ITEM
                                      ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                                    JOIN FCT_ITEMCONTRATO ITCONT
                                      ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                                    JOIN FCT_SERVICOORCA SERV
                                      ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                                    JOIN PARCNEGOCIO PARC 
                                      ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
                                    JOIN FCT_CONTRATO CONT
                                      ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                               LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
                                 ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                               LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
                                 ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
                                AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
                               LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, MAX(NRPARCELA) AS QTPARCELA
                                            FROM FCT_PARCELANEGOCONT
                                          GROUP BY NRNEGOCIACAOCONTRATO) PARCELA
                                    ON PARCELA.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO  
                                LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, DTFINALVALIDADEDESC, VRPERCDESCITEM
                                                           FROM FCT_DESCPERIODONEGOCONT
                                                          WHERE DTFINALVALIDADEDESC IS NOT NULL) DESCONTOPER
                                                      ON DESCONTOPER.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                                                     AND DESCONTOPER.DTFINALVALIDADEDESC <= FAT.DTFINCOMPET
                                 WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')
                                   AND SERV.CDSERVORCA = :CDSERVORCA
                                   AND PARC.NRPARCNEGOCIO = :NRPARCNEGOCIO
                                GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY'), PARCELA.QTPARCELA)
                   GROUP BY CDSERVORCA, NMSERVORCA, NRSEQCONTRATO, CONTRATO, NRPARCFATURA, NMPARCEIRO, COMPETENCIA2
                   ORDER BY NMSERVORCA) MES2
                 ON MES2.CDSERVORCA = BASE.CDSERVORCA
                 AND MES2.NRPARCFATURA = BASE.NRPARCFATURA
                 AND MES2.NRSEQCONTRATO = BASE.NRSEQCONTRATO
                 
                 
                 LEFT JOIN (SELECT CDSERVORCA, NMSERVORCA, NRSEQCONTRATO, CONTRATO, NRPARCFATURA, NMPARCEIRO, COMPETENCIA3, 
                                 SUM(ESTIMADO3) AS ESTIMADO3 , SUM(FATURADO3) AS FATURADO3, SUM(DIFERENCA3) AS DIFERENCA3,
                                 ROUND(((SUM(DIFERENCA3)/DECODE(SUM(ESTIMADO3),0,1,SUM(ESTIMADO3)))*100),2) AS DESVIO3
                            FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA3, 
                                         ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2) AS ESTIMADO3, 
                                         ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO3, 
                                         ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) AS DIFERENCA3,
                                         ROUND((ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) / DECODE(ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2),0,1, ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2)))*100,2) AS DESVIO3
                                    FROM FCT_FATURACONT FAT
                                    JOIN FCT_ITFATURACONT ITEM
                                      ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                                    JOIN FCT_ITEMCONTRATO ITCONT
                                      ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                                    JOIN FCT_SERVICOORCA SERV
                                      ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                                    JOIN PARCNEGOCIO PARC 
                                      ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
                                    JOIN FCT_CONTRATO CONT
                                      ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                               LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
                                 ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                               LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
                                 ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
                                AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO	   
                               LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, MAX(NRPARCELA) AS QTPARCELA
                                            FROM FCT_PARCELANEGOCONT
                                          GROUP BY NRNEGOCIACAOCONTRATO) PARCELA
                                    ON PARCELA.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO  
                                LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, DTFINALVALIDADEDESC, VRPERCDESCITEM
                                                           FROM FCT_DESCPERIODONEGOCONT
                                                          WHERE DTFINALVALIDADEDESC IS NOT NULL) DESCONTOPER
                                                      ON DESCONTOPER.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                                                     AND DESCONTOPER.DTFINALVALIDADEDESC <= FAT.DTFINCOMPET				
                                WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(SYSDATE, 'MM/YYYY')
                                  AND SERV.CDSERVORCA = :CDSERVORCA
                                  AND PARC.NRPARCNEGOCIO = :NRPARCNEGOCIO
                               GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA,  FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY'), PARCELA.QTPARCELA)
               GROUP BY CDSERVORCA, NMSERVORCA, NRSEQCONTRATO, CONTRATO, NRPARCFATURA, NMPARCEIRO, COMPETENCIA3
               ORDER BY NMSERVORCA) MES3
                 ON MES3.CDSERVORCA = BASE.CDSERVORCA
                 AND MES3.NRPARCFATURA = BASE.NRPARCFATURA
                 AND MES3.NRSEQCONTRATO = BASE.NRSEQCONTRATO
                WHERE ((MES1.COMPETENCIA1 IS NOT NULL) OR (MES2.COMPETENCIA2 IS NOT NULL) OR (MES3.COMPETENCIA3 IS NOT NULL))
               ORDER BY DESVIO1 ASC, DESVIO2 ASC, DESVIO3 ASC) C
              $conditions
              $order
              OFFSET $startPos ROWS FETCH NEXT $limit ROWS ONLY
SQL;

        $result = $this->entityManager->getConnection()->fetchAll($sql, $parametros);

        $total = empty($result) ? 0 : $result[0]['TOTAL_LINES_ZHNEXT'];
        $returnNext = [ 'data' => $result, 'pagination' => [ 'limit' => $limit, 'page' => $page, 'total' => $total]];
        return $returnNext;
    }

    // select do xml - todos os dados reunidos
    public function getDadosFaturamentoCompleto($page, $limit, $conditions, $order)
    {
      $startPos = ($page - 1) * $limit;
      $finalPos = $page * $limit;
      $sql  = <<<SQL
       SELECT  COUNT(1) OVER () TOTAL_LINES_ZHNEXT, C.* FROM (SELECT * 
        FROM (SELECT MES1.CDSERVORCA, MES1.NMSERVORCA, NULL AS NRSEQCONTRATO, NULL AS CONTRATO, NULL AS NRPARCNEGOCIO, NULL AS NMPARCEIRO,
                       NVL(MES1.COMPETENCIA1, TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')) AS COMPETENCIA1, NVL(MES1.ESTIMADO1, 0) AS ESTIMADO1, NVL(MES1.FATURADO1, 0) AS FATURADO1, NVL(MES1.DIFERENCA1, 0) AS DIFERENCA1, NVL(MES1.DESVIO1, 0) AS DESVIO1,
                       NVL(MES2.COMPETENCIA2, TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')) AS COMPETENCIA2, NVL(MES2.ESTIMADO2, 0) AS ESTIMADO2, NVL(MES2.FATURADO2, 0) AS FATURADO2, NVL(MES2.DIFERENCA2, 0) AS DIFERENCA2, NVL(MES2.DESVIO2, 0) AS DESVIO2,
                       NVL(MES3.COMPETENCIA3, TO_CHAR(SYSDATE, 'MM/YYYY')) AS COMPETENCIA3, NVL(MES3.ESTIMADO3, 0) AS ESTIMADO3, NVL(MES3.FATURADO3, 0) AS FATURADO3, NVL(MES3.DIFERENCA3, 0) AS DIFERENCA3, NVL(MES3.DESVIO3, 0) AS DESVIO3,
                       CASE WHEN ((MES1.DIFERENCA1 = 0) OR (MES2.DIFERENCA2 = 0) OR (MES3.DIFERENCA3 = 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS NAO_DIFERENCA,
                       CASE WHEN ((MES1.DESVIO1 > 0) OR (MES2.DESVIO2 > 0) OR (MES3.DESVIO3 > 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_POSITIVO,
                       CASE WHEN ((MES1.DESVIO1 < 0) OR (MES2.DESVIO2 < 0) OR (MES3.DESVIO3 < 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_NEGATIVO,
                       CASE WHEN ((MES1.DESVIO1 = 0) OR (MES2.DESVIO2 = 0) OR (MES3.DESVIO3 = 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_ZERADO,
                       '' AS DESVIO_SINAL
               FROM (SELECT CDSERVORCA, NMSERVORCA, COMPETENCIA1, SUM(ESTIMADO1) AS ESTIMADO1 , SUM(FATURADO1) AS FATURADO1, SUM(DIFERENCA1) AS DIFERENCA1,
							ROUND(((SUM(DIFERENCA1)/DECODE(SUM(ESTIMADO1),0,1,SUM(ESTIMADO1)))*100),2) AS DESVIO1
					  FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA1, 
					  
								   ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2) AS ESTIMADO1,
								   
								   ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO1, 
								   
								   ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) AS DIFERENCA1,
								   
								   ROUND((ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) / DECODE(ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2),0,1, ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2)))*100,2) AS DESVIO1
							  FROM FCT_FATURACONT FAT
							  JOIN FCT_ITFATURACONT ITEM
							    ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
				  			  JOIN FCT_ITEMCONTRATO ITCONT
							    ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
							  JOIN FCT_SERVICOORCA SERV
							    ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
						      JOIN FCT_CONTRATO CONT 
						        ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
						      LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
						        ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
						      LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
							    ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
							   AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO	
						      LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, MAX(NRPARCELA) AS QTPARCELA
								  		   FROM FCT_PARCELANEGOCONT
									      GROUP BY NRNEGOCIACAOCONTRATO) PARCELA
								ON PARCELA.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO  
							  LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, DTFINALVALIDADEDESC, VRPERCDESCITEM
                                           FROM FCT_DESCPERIODONEGOCONT
                                          WHERE DTFINALVALIDADEDESC IS NOT NULL) DESCONTOPER
                                      ON DESCONTOPER.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                                     AND DESCONTOPER.DTFINALVALIDADEDESC <= FAT.DTFINCOMPET
							 WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')
							 GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY'), PARCELA.QTPARCELA)
					GROUP BY CDSERVORCA, NMSERVORCA, COMPETENCIA1
                    ORDER BY  NMSERVORCA) MES1
               LEFT JOIN (SELECT CDSERVORCA, NMSERVORCA, COMPETENCIA2, SUM(ESTIMADO2) AS ESTIMADO2 , SUM(FATURADO2) AS FATURADO2, SUM(DIFERENCA2) AS DIFERENCA2,
							ROUND(((SUM(DIFERENCA2)/DECODE(SUM(ESTIMADO2),0,1,SUM(ESTIMADO2)))*100),2) AS DESVIO2
					  FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA2, 
								   ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2) AS ESTIMADO2,
								   ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO2, 
								   ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) AS DIFERENCA2,
								   ROUND((ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) / DECODE(ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2),0,1, ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2)))*100,2) AS DESVIO2
							  FROM FCT_FATURACONT FAT
							  JOIN FCT_ITFATURACONT ITEM
							    ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
				  			  JOIN FCT_ITEMCONTRATO ITCONT
							    ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
							  JOIN FCT_SERVICOORCA SERV
							    ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
						      JOIN FCT_CONTRATO CONT 
						        ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
						      LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
						        ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
						      LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
							    ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
							   AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO	
						      LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, MAX(NRPARCELA) AS QTPARCELA
								  		   FROM FCT_PARCELANEGOCONT
									      GROUP BY NRNEGOCIACAOCONTRATO) PARCELA
								ON PARCELA.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
							  LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, DTFINALVALIDADEDESC, VRPERCDESCITEM
                                           FROM FCT_DESCPERIODONEGOCONT
                                          WHERE DTFINALVALIDADEDESC IS NOT NULL) DESCONTOPER
                                      ON DESCONTOPER.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                                     AND DESCONTOPER.DTFINALVALIDADEDESC <= FAT.DTFINCOMPET
							 WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')
							 GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY'), PARCELA.QTPARCELA)
					GROUP BY CDSERVORCA, NMSERVORCA, COMPETENCIA2
                    ORDER BY  NMSERVORCA) MES2
                 ON MES2.CDSERVORCA = MES1.CDSERVORCA
               LEFT JOIN (SELECT CDSERVORCA, NMSERVORCA, COMPETENCIA3, SUM(ESTIMADO3) AS ESTIMADO3 , SUM(FATURADO3) AS FATURADO3, SUM(DIFERENCA3) AS DIFERENCA3,
							ROUND(((SUM(DIFERENCA3)/DECODE(SUM(ESTIMADO3),0,1,SUM(ESTIMADO3)))*100),2) AS DESVIO3
					  FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA3, 
								   ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2) AS ESTIMADO3,
								   ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO3, 
								   ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) AS DIFERENCA3,
								   ROUND((ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) / DECODE(ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2),0,1, ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2)))*100,2) AS DESVIO3
							  FROM FCT_FATURACONT FAT
							  JOIN FCT_ITFATURACONT ITEM
							    ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
				  			  JOIN FCT_ITEMCONTRATO ITCONT
							    ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
							  JOIN FCT_SERVICOORCA SERV
							    ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
						      JOIN FCT_CONTRATO CONT 
						        ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
						      LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
						        ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
						      LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
							    ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
							   AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO	
						      LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, MAX(NRPARCELA) AS QTPARCELA
								  		   FROM FCT_PARCELANEGOCONT
									      GROUP BY NRNEGOCIACAOCONTRATO) PARCELA
								ON PARCELA.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO  
							  LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, DTFINALVALIDADEDESC, VRPERCDESCITEM
                                           FROM FCT_DESCPERIODONEGOCONT
                                          WHERE DTFINALVALIDADEDESC IS NOT NULL) DESCONTOPER
                                      ON DESCONTOPER.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                                     AND DESCONTOPER.DTFINALVALIDADEDESC <= FAT.DTFINCOMPET
							 WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(SYSDATE , 'MM/YYYY')
							 GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY'), PARCELA.QTPARCELA)
					GROUP BY CDSERVORCA, NMSERVORCA, COMPETENCIA3
                    ORDER BY  NMSERVORCA) MES3
                 ON MES3.CDSERVORCA = MES1.CDSERVORCA
          
          UNION ALL
          
          SELECT DISTINCT BASE.CDSERVORCA, BASE.NMSERVORCA,  NULL AS NRSEQCONTRATO, NULL AS CONTRATO, BASE.NRPARCFATURA AS NRPARCNEGOCIO, BASE.NMPARCEIRO,
                       NVL(MES1.COMPETENCIA1, TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')) AS COMPETENCIA1, NVL(MES1.ESTIMADO1, 0) AS ESTIMADO1, NVL(MES1.FATURADO1, 0) AS FATURADO1, NVL(MES1.DIFERENCA1, 0) AS DIFERENCA1, NVL(MES1.DESVIO1, 0) AS DESVIO1,
                       NVL(MES2.COMPETENCIA2, TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')) AS COMPETENCIA2, NVL(MES2.ESTIMADO2, 0) AS ESTIMADO2, NVL(MES2.FATURADO2, 0) AS FATURADO2, NVL(MES2.DIFERENCA2, 0) AS DIFERENCA2, NVL(MES2.DESVIO2, 0) AS DESVIO2,
                       NVL(MES3.COMPETENCIA3, TO_CHAR(SYSDATE, 'MM/YYYY')) AS COMPETENCIA3, NVL(MES3.ESTIMADO3, 0) AS ESTIMADO3, NVL(MES3.FATURADO3, 0) AS FATURADO3, NVL(MES3.DIFERENCA3, 0) AS DIFERENCA3, NVL(MES3.DESVIO3, 0) AS DESVIO3,
                       CASE WHEN ((MES1.DIFERENCA1 = 0) OR (MES2.DIFERENCA2 = 0) OR (MES3.DIFERENCA3 = 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS NAO_DIFERENCA,
                       CASE WHEN ((MES1.DESVIO1 > 0) OR (MES2.DESVIO2 > 0) OR (MES3.DESVIO3 > 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_POSITIVO,
                       CASE WHEN ((MES1.DESVIO1 < 0) OR (MES2.DESVIO2 < 0) OR (MES3.DESVIO3 < 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_NEGATIVO,
                       CASE WHEN ((MES1.DESVIO1 = 0) OR (MES2.DESVIO2 = 0) OR (MES3.DESVIO3 = 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_ZERADO,
                       '' AS DESVIO_SINAL
                 FROM (SELECT DISTINCT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRPARCNEGOCIO AS NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO
                         FROM FCT_CONTRATO CONT
                         JOIN PARCNEGOCIO PARC 
                           ON PARC.NRPARCNEGOCIO = CONT.NRPARCNEGOCIO
                         JOIN FCT_ITEMCONTRATO ITCONT
                           ON ITCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                         JOIN FCT_SERVICOORCA SERV
                           ON SERV.CDSERVORCA = ITCONT.CDSERVORCA) BASE 
                 
                LEFT JOIN (SELECT CDSERVORCA, NMSERVORCA, NRPARCFATURA, NMPARCEIRO, COMPETENCIA1, SUM(ESTIMADO1) AS ESTIMADO1 , SUM(FATURADO1) AS FATURADO1, SUM(DIFERENCA1) AS DIFERENCA1,
							ROUND(((SUM(DIFERENCA1)/DECODE(SUM(ESTIMADO1),0,1,SUM(ESTIMADO1)))*100),2) AS DESVIO1
					  FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA1, 
                                   ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2) AS ESTIMADO1, 
                                   ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO1, 
                                   ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) AS DIFERENCA1,
                                   ROUND((ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) / DECODE(ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2),0,1, ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2)))*100, 2) AS DESVIO1
                                   FROM FCT_FATURACONT FAT
                             JOIN FCT_ITFATURACONT ITEM
                               ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                             JOIN FCT_ITEMCONTRATO ITCONT
                               ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                             JOIN FCT_SERVICOORCA SERV
                               ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                             JOIN PARCNEGOCIO PARC 
                               ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
                           JOIN FCT_CONTRATO CONT 
                           ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                           LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
                           ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                           LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
                           ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
                           AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
                           LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, MAX(NRPARCELA) AS QTPARCELA
                                        FROM FCT_PARCELANEGOCONT
                                      GROUP BY NRNEGOCIACAOCONTRATO) PARCELA
                                ON PARCELA.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO  
                           LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, DTFINALVALIDADEDESC, VRPERCDESCITEM
                                                       FROM FCT_DESCPERIODONEGOCONT
                                                      WHERE DTFINALVALIDADEDESC IS NOT NULL) DESCONTOPER
                                                  ON DESCONTOPER.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                                                 AND DESCONTOPER.DTFINALVALIDADEDESC <= FAT.DTFINCOMPET	
                           WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')
                             GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY'), PARCELA.QTPARCELA)
               GROUP BY CDSERVORCA, NMSERVORCA, NRPARCFATURA, NMPARCEIRO, COMPETENCIA1
               ORDER BY NMSERVORCA ) MES1
               ON MES1.CDSERVORCA = BASE.CDSERVORCA
               AND MES1.NRPARCFATURA = BASE.NRPARCFATURA    
                   
               LEFT JOIN (SELECT CDSERVORCA, NMSERVORCA, NRPARCFATURA, NMPARCEIRO, COMPETENCIA2, SUM(ESTIMADO2) AS ESTIMADO2 , SUM(FATURADO2) AS FATURADO2, SUM(DIFERENCA2) AS DIFERENCA2,
							ROUND(((SUM(DIFERENCA2)/DECODE(SUM(ESTIMADO2),0,1,SUM(ESTIMADO2)))*100),2) AS DESVIO2
					  FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO,  TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA2, 
                                   ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2) AS ESTIMADO2, 
                                   ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO2, 
                                   ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) AS DIFERENCA2,
                                   ROUND((ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) / DECODE(ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2),0,1, ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2)))*100,2) AS DESVIO2
                              FROM FCT_FATURACONT FAT
                              JOIN FCT_ITFATURACONT ITEM
                                ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                              JOIN FCT_ITEMCONTRATO ITCONT
                                ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                              JOIN FCT_SERVICOORCA SERV
                                ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                              JOIN PARCNEGOCIO PARC 
                                ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
                              JOIN FCT_CONTRATO CONT 
                           ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                           LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
                           ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                           LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
                           ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
                           AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO 
                           LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, MAX(NRPARCELA) AS QTPARCELA
                                        FROM FCT_PARCELANEGOCONT
                                      GROUP BY NRNEGOCIACAOCONTRATO) PARCELA
                                ON PARCELA.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                           LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, DTFINALVALIDADEDESC, VRPERCDESCITEM
                                                       FROM FCT_DESCPERIODONEGOCONT
                                                      WHERE DTFINALVALIDADEDESC IS NOT NULL) DESCONTOPER
                                                  ON DESCONTOPER.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                                                 AND DESCONTOPER.DTFINALVALIDADEDESC <= FAT.DTFINCOMPET
                           WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')
                             GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )',  TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY'), PARCELA.QTPARCELA)
                 GROUP BY CDSERVORCA, NMSERVORCA, NRPARCFATURA, NMPARCEIRO, COMPETENCIA2
                 ORDER BY NMSERVORCA) MES2
               ON MES2.CDSERVORCA = BASE.CDSERVORCA
               AND MES2.NRPARCFATURA = BASE.NRPARCFATURA
               
               
               LEFT JOIN (
               SELECT CDSERVORCA, NMSERVORCA, NRPARCFATURA, NMPARCEIRO, COMPETENCIA3, SUM(ESTIMADO3) AS ESTIMADO3 , SUM(FATURADO3) AS FATURADO3, SUM(DIFERENCA3) AS DIFERENCA3,
							ROUND(((SUM(DIFERENCA3)/DECODE(SUM(ESTIMADO3),0,1,SUM(ESTIMADO3)))*100),2) AS DESVIO3
					  FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA,  FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA3, 
                                   ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2) AS ESTIMADO3, 
                                   ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO3, 
                                   ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) AS DIFERENCA3,
                                   ROUND((ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) / DECODE(ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2),0,1, ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2)))*100,2) AS DESVIO3
                         FROM FCT_FATURACONT FAT
                         JOIN FCT_ITFATURACONT ITEM
                           ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                         JOIN FCT_ITEMCONTRATO ITCONT
                           ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                         JOIN FCT_SERVICOORCA SERV
                           ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                         JOIN PARCNEGOCIO PARC 
                           ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
                       JOIN FCT_CONTRATO CONT 
                       ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                       LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
                       ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                       LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
                       ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
                       AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
                       LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, MAX(NRPARCELA) AS QTPARCELA
                                    FROM FCT_PARCELANEGOCONT
                                  GROUP BY NRNEGOCIACAOCONTRATO) PARCELA
                            ON PARCELA.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO  
                        LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, DTFINALVALIDADEDESC, VRPERCDESCITEM
                                                   FROM FCT_DESCPERIODONEGOCONT
                                                  WHERE DTFINALVALIDADEDESC IS NOT NULL) DESCONTOPER
                                              ON DESCONTOPER.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                                             AND DESCONTOPER.DTFINALVALIDADEDESC <= FAT.DTFINCOMPET	
                       WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(SYSDATE, 'MM/YYYY')
                       GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA,  FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY'), PARCELA.QTPARCELA)
               GROUP BY  CDSERVORCA, NMSERVORCA, NRPARCFATURA, NMPARCEIRO, COMPETENCIA3
               ORDER BY  NMSERVORCA) MES3
               ON MES3.CDSERVORCA = BASE.CDSERVORCA
               AND MES3.NRPARCFATURA = BASE.NRPARCFATURA
               WHERE ((MES1.COMPETENCIA1 IS NOT NULL) OR (MES2.COMPETENCIA2 IS NOT NULL) OR (MES3.COMPETENCIA3 IS NOT NULL))
          
          UNION ALL
          
          SELECT BASE.CDSERVORCA, BASE.NMSERVORCA, BASE.NRSEQCONTRATO, BASE.CONTRATO, BASE.NRPARCFATURA, BASE.NMPARCEIRO, 
                       NVL(MES1.COMPETENCIA1, TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')) AS COMPETENCIA1, NVL(MES1.ESTIMADO1, 0) AS ESTIMADO1, NVL(MES1.FATURADO1, 0) AS FATURADO1, NVL(MES1.DIFERENCA1, 0) AS DIFERENCA1, NVL(MES1.DESVIO1, 0) AS DESVIO1,
                       NVL(MES2.COMPETENCIA2, TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')) AS COMPETENCIA2, NVL(MES2.ESTIMADO2, 0) AS ESTIMADO2, NVL(MES2.FATURADO2, 0) AS FATURADO2, NVL(MES2.DIFERENCA2, 0) AS DIFERENCA2, NVL(MES2.DESVIO2, 0) AS DESVIO2,
                       NVL(MES3.COMPETENCIA3, TO_CHAR(SYSDATE, 'MM/YYYY')) AS COMPETENCIA3, NVL(MES3.ESTIMADO3, 0) AS ESTIMADO3, NVL(MES3.FATURADO3, 0) AS FATURADO3, NVL(MES3.DIFERENCA3, 0) AS DIFERENCA3, NVL(MES3.DESVIO3, 0) AS DESVIO3,
                       CASE WHEN ((MES1.DIFERENCA1 = 0) OR (MES2.DIFERENCA2 = 0) OR (MES3.DIFERENCA3 = 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS NAO_DIFERENCA,
                       CASE WHEN ((MES1.DESVIO1 > 0) OR (MES2.DESVIO2 > 0) OR (MES3.DESVIO3 > 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_POSITIVO,
                       CASE WHEN ((MES1.DESVIO1 < 0) OR (MES2.DESVIO2 < 0) OR (MES3.DESVIO3 < 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_NEGATIVO,
                       CASE WHEN ((MES1.DESVIO1 = 0) OR (MES2.DESVIO2 = 0) OR (MES3.DESVIO3 = 0)) 
                         THEN 'S'
                         ELSE 'N'
                       END AS DESVIO_ZERADO,
                       '' AS DESVIO_SINAL
                 FROM 
                 (SELECT DISTINCT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRPARCNEGOCIO AS NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO
                         FROM FCT_CONTRATO CONT
                         JOIN PARCNEGOCIO PARC 
                           ON PARC.NRPARCNEGOCIO = CONT.NRPARCNEGOCIO
                         JOIN FCT_ITEMCONTRATO ITCONT
                           ON ITCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                         JOIN FCT_SERVICOORCA SERV
                           ON SERV.CDSERVORCA = ITCONT.CDSERVORCA) BASE 
                          
                 LEFT JOIN (SELECT CDSERVORCA, NMSERVORCA, NRSEQCONTRATO, CONTRATO, NRPARCFATURA, NMPARCEIRO, COMPETENCIA1, SUM(ESTIMADO1) AS ESTIMADO1 , SUM(FATURADO1) AS FATURADO1, SUM(DIFERENCA1) AS DIFERENCA1,
                                   ROUND(((SUM(DIFERENCA1)/DECODE(SUM(ESTIMADO1),0,1,SUM(ESTIMADO1)))*100),2) AS DESVIO1
                            FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA1, 
                                         ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2) AS ESTIMADO1, 
                                         ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO1, 
                                         ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) AS DIFERENCA1,
                                         ROUND((ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) / DECODE(ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2),0,1, ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2)))*100,2) AS DESVIO1
                                    FROM FCT_FATURACONT FAT
                                    JOIN FCT_ITFATURACONT ITEM
                                      ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                                    JOIN FCT_ITEMCONTRATO ITCONT
                                      ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                                    JOIN FCT_SERVICOORCA SERV
                                      ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                                    JOIN PARCNEGOCIO PARC 
                                      ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
                                    JOIN FCT_CONTRATO CONT
                                      ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                               LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
                                 ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                               LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
                                 ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
                                AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
                               LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, MAX(NRPARCELA) AS QTPARCELA
                                            FROM FCT_PARCELANEGOCONT
                                          GROUP BY NRNEGOCIACAOCONTRATO) PARCELA
                                    ON PARCELA.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO  
                               LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, DTFINALVALIDADEDESC, VRPERCDESCITEM
                                            FROM FCT_DESCPERIODONEGOCONT
                                           WHERE DTFINALVALIDADEDESC IS NOT NULL) DESCONTOPER
                                      ON DESCONTOPER.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                                     AND DESCONTOPER.DTFINALVALIDADEDESC <= FAT.DTFINCOMPET
                                 WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2) , 'MM/YYYY')
                                GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY'), PARCELA.QTPARCELA)
                   GROUP BY CDSERVORCA, NMSERVORCA, NRSEQCONTRATO, CONTRATO, NRPARCFATURA, NMPARCEIRO, COMPETENCIA1 
                   ORDER BY NMSERVORCA) MES1
                ON MES1.CDSERVORCA = BASE.CDSERVORCA
                 AND MES1.NRPARCFATURA = BASE.NRPARCFATURA
                 AND MES1.NRSEQCONTRATO = BASE.NRSEQCONTRATO 
                   
               LEFT JOIN (SELECT CDSERVORCA, NMSERVORCA, NRSEQCONTRATO, CONTRATO, NRPARCFATURA, NMPARCEIRO, COMPETENCIA2, 
                                 SUM(ESTIMADO2) AS ESTIMADO2 , SUM(FATURADO2) AS FATURADO2, SUM(DIFERENCA2) AS DIFERENCA2,
                                 ROUND(((SUM(DIFERENCA2)/DECODE(SUM(ESTIMADO2),0,1,SUM(ESTIMADO2)))*100),2) AS DESVIO2
                            FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO,  TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA2, 
                                         ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2) AS ESTIMADO2, 
                                         ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO2, 
                                         ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) AS DIFERENCA2,
                                         ROUND((ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) / DECODE(ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2),0,1, ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2)))*100,2) AS DESVIO2 
                                    FROM FCT_FATURACONT FAT
                                    JOIN FCT_ITFATURACONT ITEM
                                      ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                                    JOIN FCT_ITEMCONTRATO ITCONT
                                      ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                                    JOIN FCT_SERVICOORCA SERV
                                      ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                                    JOIN PARCNEGOCIO PARC 
                                      ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
                                    JOIN FCT_CONTRATO CONT
                                      ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                               LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
                                 ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                               LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
                                 ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
                                AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
                               LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, MAX(NRPARCELA) AS QTPARCELA
                                            FROM FCT_PARCELANEGOCONT
                                          GROUP BY NRNEGOCIACAOCONTRATO) PARCELA
                                    ON PARCELA.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO  
                                LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, DTFINALVALIDADEDESC, VRPERCDESCITEM
                                                           FROM FCT_DESCPERIODONEGOCONT
                                                          WHERE DTFINALVALIDADEDESC IS NOT NULL) DESCONTOPER
                                                      ON DESCONTOPER.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                                                     AND DESCONTOPER.DTFINALVALIDADEDESC <= FAT.DTFINCOMPET
                                 WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1) , 'MM/YYYY')
                                GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY'), PARCELA.QTPARCELA)
                   GROUP BY CDSERVORCA, NMSERVORCA, NRSEQCONTRATO, CONTRATO, NRPARCFATURA, NMPARCEIRO, COMPETENCIA2
                   ORDER BY NMSERVORCA) MES2
                 ON MES2.CDSERVORCA = BASE.CDSERVORCA
                 AND MES2.NRPARCFATURA = BASE.NRPARCFATURA
                 AND MES2.NRSEQCONTRATO = BASE.NRSEQCONTRATO
                 
                 
                 LEFT JOIN (SELECT CDSERVORCA, NMSERVORCA, NRSEQCONTRATO, CONTRATO, NRPARCFATURA, NMPARCEIRO, COMPETENCIA3, 
                                 SUM(ESTIMADO3) AS ESTIMADO3 , SUM(FATURADO3) AS FATURADO3, SUM(DIFERENCA3) AS DIFERENCA3,
                                 ROUND(((SUM(DIFERENCA3)/DECODE(SUM(ESTIMADO3),0,1,SUM(ESTIMADO3)))*100),2) AS DESVIO3
                            FROM (SELECT ITCONT.CDSERVORCA, SERV.NMSERVORCA, CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT AS CONTRATO, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') AS COMPETENCIA3, 
                                         ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2) AS ESTIMADO3, 
                                         ROUND(SUM(ITEM.VRFATURADO),2) AS FATURADO3, 
                                         ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) AS DIFERENCA3,
                                         ROUND((ROUND((SUM(ITEM.VRFATURADO) - (SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1))),2) / DECODE(ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2),0,1, ROUND((SUM(DECODE(NVL(DESCONTOPER.VRPERCDESCITEM,0), 0 ,DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100)) , ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) - ((DECODE(NVL(NEGCONT.VRPERCDESCITEM,0), 0, DECODE(NVL(ITNEGCONT.VRPERCDESCITEM,0) , 0, ITCONT.VRTOTITEMCONT, ITCONT.VRTOTITEMCONT - ( ( (ITCONT.VRTOTITEMCONT*ITNEGCONT.VRPERCDESCITEM)/100)), ITCONT.VRTOTITEMCONT - ((ITCONT.VRTOTITEMCONT*NEGCONT.VRPERCDESCITEM)/100))) * DESCONTOPER.VRPERCDESCITEM )/100))))/NVL(PARCELA.QTPARCELA,1)),2)))*100,2) AS DESVIO3
                                    FROM FCT_FATURACONT FAT
                                    JOIN FCT_ITFATURACONT ITEM
                                      ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
                                    JOIN FCT_ITEMCONTRATO ITCONT
                                      ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
                                    JOIN FCT_SERVICOORCA SERV
                                      ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
                                    JOIN PARCNEGOCIO PARC 
                                      ON PARC.NRPARCNEGOCIO = FAT.NRPARCFATURA
                                    JOIN FCT_CONTRATO CONT
                                      ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                               LEFT JOIN FCT_NEGOCIACAOCONTRATO NEGCONT
                                 ON NEGCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                               LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEGCONT
                                 ON ITNEGCONT.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO
                                AND ITNEGCONT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO	   
                               LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, MAX(NRPARCELA) AS QTPARCELA
                                            FROM FCT_PARCELANEGOCONT
                                          GROUP BY NRNEGOCIACAOCONTRATO) PARCELA
                                    ON PARCELA.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO  
                                LEFT JOIN (SELECT NRNEGOCIACAOCONTRATO, DTFINALVALIDADEDESC, VRPERCDESCITEM
                                                           FROM FCT_DESCPERIODONEGOCONT
                                                          WHERE DTFINALVALIDADEDESC IS NOT NULL) DESCONTOPER
                                                      ON DESCONTOPER.NRNEGOCIACAOCONTRATO = NEGCONT.NRNEGOCIACAOCONTRATO 
                                                     AND DESCONTOPER.DTFINALVALIDADEDESC <= FAT.DTFINCOMPET				
                                WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(SYSDATE, 'MM/YYYY')
                               GROUP BY ITCONT.CDSERVORCA, SERV.NMSERVORCA,  FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )', CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY'), PARCELA.QTPARCELA)
               GROUP BY CDSERVORCA, NMSERVORCA, NRSEQCONTRATO, CONTRATO, NRPARCFATURA, NMPARCEIRO, COMPETENCIA3
               ORDER BY NMSERVORCA) MES3
                 ON MES3.CDSERVORCA = BASE.CDSERVORCA
                 AND MES3.NRPARCFATURA = BASE.NRPARCFATURA
                 AND MES3.NRSEQCONTRATO = BASE.NRSEQCONTRATO
                WHERE ((MES1.COMPETENCIA1 IS NOT NULL) OR (MES2.COMPETENCIA2 IS NOT NULL) OR (MES3.COMPETENCIA3 IS NOT NULL))
               )
          ORDER BY CDSERVORCA, NRPARCNEGOCIO DESC, NRSEQCONTRATO DESC) C
              $conditions
              $order
              OFFSET $startPos ROWS FETCH NEXT $limit ROWS ONLY
SQL;

        $result = $this->entityManager->getConnection()->fetchAll($sql);

        $total = empty($result) ? 0 : $result[0]['TOTAL_LINES_ZHNEXT'];
        $returnNext = [ 'data' => $result, 'pagination' => [ 'limit' => $limit, 'page' => $page, 'total' => $total]];
        return $returnNext;
    }
}
